<!DOCTYPE html>
<html lang="en">

<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1">
  <title>AdminLTE 3 | Dashboard 3</title>

  <!-- Google Font: Source Sans Pro -->
  <link rel="stylesheet"
    href="https://fonts.googleapis.com/css?family=Source+Sans+Pro:300,400,400i,700&display=fallback">
  <!-- Font Awesome Icons -->
  <link rel="stylesheet" href="plugins/fontawesome-free/css/all.min.css">
  <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/6.4.0/css/all.min.css">
  <!-- IonIcons -->
  <link rel="stylesheet" href="https://code.ionicframework.com/ionicons/2.0.1/css/ionicons.min.css">
  <!-- Theme style -->
  <link rel="stylesheet" href="dist/css/adminlte.min.css">
   <!-- Import DataTable Library -->
   <link rel="stylesheet" href="https://cdn.datatables.net/1.13.4/css/dataTables.bootstrap4.min.css">
</head>
<!--
`body` tag options:

  Apply one or more of the following classes to to the body tag
  to get the desired effect

  * sidebar-collapse
  * sidebar-mini
-->

<body class="hold-transition sidebar-mini">
  <div class="wrapper">
    <!-- Navbar -->
    <nav class="main-header navbar navbar-expand navbar-white navbar-light">
      <!-- Left navbar links -->
      <ul class="navbar-nav">
        <li class="nav-item">
          <a class="nav-link" data-widget="pushmenu" href="#" role="button"><i class="fas fa-bars"></i></a>
        </li>
        <li class="nav-item d-none d-sm-inline-block">
          <a href="index3.html" class="nav-link">Home</a>
        </li>
        <li class="nav-item d-none d-sm-inline-block">
          <a href="#" class="nav-link">Data User</a>
        </li>
      </ul>
    </nav>
    <!-- /.navbar -->

    <!-- Main Sidebar Container -->
    <aside class="main-sidebar sidebar-dark-primary elevation-4">
      <!-- Brand Logo -->
      <a href="index3.html" class="brand-link">
        <img src="dist/img/AdminLTELogo.png" alt="AdminLTE Logo" class="brand-image img-circle elevation-3"
          style="opacity: .8">
        <span class="brand-text font-weight-light">Task 48.50</span>
      </a>

      <!-- Sidebar -->
      <div class="sidebar">
        <!-- Sidebar user panel (optional) -->
        <div class="user-panel mt-3 pb-3 mb-3 d-flex">
          <div class="image">
            <img src="dist/img/user2-160x160.jpg" class="img-circle elevation-2" alt="User Image">
          </div>
          <div class="info">
            <a href="#" class="d-block">Baodtg</a>
          </div>
        </div>

        <!-- SidebarSearch Form -->
        <div class="form-inline">
          <div class="input-group" data-widget="sidebar-search">
            <input class="form-control form-control-sidebar" type="search" placeholder="Search" aria-label="Search">
            <div class="input-group-append">
              <button class="btn btn-sidebar">
                <i class="fas fa-search fa-fw"></i>
              </button>
            </div>
          </div>
        </div>

        <!-- Sidebar Menu -->
        <nav class="mt-2">
          <ul class="nav nav-pills nav-sidebar flex-column" data-widget="treeview" role="menu" data-accordion="false">
            <!-- Add icons to the links using the .nav-icon class
               with font-awesome or any other icon font library -->
            <li class="nav-item menu-open">
              <a href="#" class="nav-link active">
                <i class="nav-icon fas fa-tachometer-alt"></i>
                <p>
                  Dashboard
                  <i class="right fas fa-angle-left"></i>
                </p>
              </a>
              <ul class="nav nav-treeview">
                <li class="nav-item">
                  <a href="#" class="nav-link">
                    <i class="far fa-circle nav-icon"></i>
                    <p>Dashboard v1</p>
                  </a>
                </li>
                <li class="nav-item">
                  <a href="#" class="nav-link">
                    <i class="far fa-circle nav-icon"></i>
                    <p>Dashboard v2</p>
                  </a>
                </li>
                <li class="nav-item">
                  <a href="adminDataUser.html" class="nav-link active">
                    <i class="far fa-circle nav-icon"></i>
                    <p>Dashboard v3</p>
                  </a>
                </li>
              </ul>
            </li>
          </ul>
        </nav>
        <!-- /.sidebar-menu -->
      </div>
      <!-- /.sidebar -->
    </aside>

    <!-- Content Wrapper. Contains page content -->
    <div class="content-wrapper">
      <!-- Content Header (Page header) -->
      <div class="content-header">
        <div class="container-fluid">
          <div class="row mb-2">
            <div class="col-sm-6">
              <h1 class="m-0">Data User</h1>
            </div><!-- /.col -->
            <div class="col-sm-6">
              <ol class="breadcrumb float-sm-right">
                <li class="breadcrumb-item"><a href="#">Home</a></li>
                <li class="breadcrumb-item active">User</li>
              </ol>
            </div><!-- /.col -->
          </div><!-- /.row -->
        </div><!-- /.container-fluid -->
      </div>
      <!-- /.content-header -->

      <!-- Main content -->
      <div class="content">
        <div class="container-fluid">
          <div class="text-center">
            <h3>F100 - QUẢN TRỊ NGƯỜI DÙNG</h3>
          </div>
          <div class="div-filter jumbotron">
            <div class="d-flex h-100 justify-content-around">
              <label class="" for="select-role" style="font-weight: 500;">Role</label>
              <select name="" id="select-role" class="bg-info text-white w-50">
                <option value="0">Chọn một Role</option>
              </select>
              <button id="btn-filter" class="btn btn-success">Lọc dữ liệu</button>
            </div>
          </div>
          <table id="users-table" class="table table-bordered table-striped table-hover table-primary">
            <thead class="text-light" style="font-weight: 500; ">
              <tr>
                <td>STT</td>
                <td>Username</td>
                <td>First name</td>
                <td>Last name</td>
                <td>Email</td>
                <td>Age</td>
                <td>Role</td>
                <td>Action</td>
              </tr>
            </thead>
          </table>
        </div>
      </div>
    </div>
    <!-- /.content-wrapper -->

    <!-- Control Sidebar -->
    <aside class="control-sidebar control-sidebar-dark">
      <!-- Control sidebar content goes here -->
    </aside>
    <!-- /.control-sidebar -->

    <!-- Main Footer -->
    <footer class="main-footer">
      <strong>Copyright &copy; 2014-2021 <a href="https://adminlte.io">AdminLTE.io</a>.</strong>
      All rights reserved.
      <div class="float-right d-none d-sm-inline-block">
        <b>Version</b> 3.2.0
      </div>
    </footer>
  </div>
  <!-- ./wrapper -->

  <!-- REQUIRED SCRIPTS -->

  <!-- jQuery -->
  <script src="plugins/jquery/jquery.min.js"></script>
  <!-- Bootstrap -->
  <script src="plugins/bootstrap/js/bootstrap.bundle.min.js"></script>
  <!-- AdminLTE -->
  <script src="dist/js/adminlte.js"></script>
  <!-- data table -->
  <script src="https://cdn.datatables.net/1.13.4/js/jquery.dataTables.min.js"></script>
  <script src="https://cdn.datatables.net/1.13.4/js/dataTables.bootstrap4.min.js"></script>



</body>
<script>
  /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
  // Mảng gUserObjects là mảng chứa dữ liệu users
  var gUserObjects = [
    {
      id: 2,
      username: "quannv",
      firstname: "Ngo Van",
      lastname: "Quan",
      age: 18,
      email: "quan@gmail.com",
      roleId: 5
    },
    {
      id: 3,
      username: "longdh",
      firstname: "Do Hoang",
      lastname: "Long",
      age: 19,
      email: "long@gmail.com",
      roleId: 8
    },
    {
      id: 4,
      username: "hiendt",
      firstname: "Do Thi",
      lastname: "Hien",
      age: 29,
      email: "hien@gmail.com",
      roleId: 11
    },
    {
      id: 6,
      username: "lanht",
      firstname: "Ho Thi",
      lastname: "Lan",
      age: 27,
      email: "lan@gmail.com",
      roleId: 13
    },
    {
      id: 7,
      username: "lanhtt",
      firstname: "Ho Thiee",
      lastname: "Lang",
      age: 28,
      email: "lan@gmail.com",
      roleId: 13
    }
  ];
  // Mảng gRoleObjects là mảng chứa dữ liệu các roles
  var gRoleObjects = [
    {
      roleId: 5,
      roleName: "Admin"
    },
    {
      roleId: 8,
      roleName: "Manager"
    },
    {
      roleId: 11,
      roleName: "Teacher"
    },
    {
      roleId: 13,
      roleName: "Staff"
    }
  ];
  var gSTT = 1;
  /*** REGION 2 - Vùng gán / thực thi hàm xử lý sự kiện cho các elements */
  onPageLoading();
  $("#btn-filter").on("click", function() {
    var vFilteredUser = gUserObjects.filter(filterByRoleId);
    console.log(vFilteredUser)
    loadDataToTable(vFilteredUser)
  })
  /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
  function onPageLoading() {
    var vUsersDataTable = $("#users-table").DataTable({
      paging: false,
      lengthChange: false,
      ordering: false,
      searching: false,
      data: gUserObjects,
      columns: [
        { data: "id" },
        { data: "username" },
        { data: "firstname" },
        { data: "lastname" },
        { data: "age" },
        { data: "email" },
        { data: "roleId" },
        { data: "action" },
      ],
      columnDefs: [
        {
          target: 0,
          render: renderSTT
        },
        {
          target: 7,
          "defaultContent": `
          <i class="fa-solid fa-dice" style="cursor: pointer" data-toggle="tooltip" title="Dice History"></i> 
          <i class="fa-solid fa-gift" style="cursor: pointer" data-toggle="tooltip" title="Voucher History"></i>
        
        `
        },
        {
          target: 6,
          render: renderRoleIdToRoleName
        }
      ]
    });
    loadDataToSelect();
  }
  /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
  //hàm render STT: 
  function renderSTT() {
    return gSTT++
  };
  //hàm load data to select role
  function loadDataToSelect() {
    for (let bI = 0; bI < gRoleObjects.length; bI++) {
      $("#select-role").append(`
      <option value="${gRoleObjects[bI].roleId}">${gRoleObjects[bI].roleName}</option>
      `)
    }
  };
  //hàm render role id to role name:
  function renderRoleIdToRoleName(paramData) {
    for (var bI = 0; bI < gRoleObjects.length; bI++) {
      if (gRoleObjects[bI].roleId == paramData) {
        paramData = gRoleObjects[bI].roleName;
        return paramData
      }
    }
  }
  //hàm filter by role ID:
  function filterByRoleId(paramRoleElement) {
    return paramRoleElement.roleId == $("#select-role").val();
  };
   //hàm load data filtered to table:
   function loadDataToTable(paramUserData) {
    var vTable = $("#users-table").DataTable();
    vTable.clear();
    vTable.rows.add(paramUserData);
    vTable.draw();
   }
</script>

</html>